		.macro LD_R0_IMM VALUE
		ldi		r16,(\VALUE)
		mov		r0,r16
		.endm

		.macro CP_R0_IMM VALUE
		ldi		r16,(\VALUE)
		cp		r0,r16
		.endm

		.macro SUB_R0_IMM VALUE
		ldi		r16,(\VALUE)
		sub		r0,r16
		.endm

		.macro ADD_R0_IMM VALUE
		ldi		r16,(\VALUE)
		add		r0,r16
		.endm

		.macro AND_R0_IMM VALUE
		ldi		r16,(\VALUE)
		and		r0,r16
		.endm

		.macro OR_R0_IMM VALUE
		ldi		r16,(\VALUE)
		or		r0,r16
		.endm

;        .macro LDZIMM VALUE
;		ldi		r30,((\VALUE) << 1) & 0x00FF
;		ldi		r31,(\VALUE) >> 7
;		.endm

        .macro LDZIMM VALUE
		ldi		r30,lo8(\VALUE)
		ldi		r31,hi8(\VALUE)
		.endm

		.macro LD_R18_IMM VALUE
		ldi		r18,hi8(\VALUE)
		ldi		r19,lo8(\VALUE)
		.endm

		.macro LD_R20_IMM VALUE
		ldi		r20,lo8(\VALUE)
		ldi		r21,hi8(\VALUE)
		.endm

		.macro LD_R26_IMM VALUE
		ldi		r26,lo8(\VALUE)
		ldi		r27,hi8(\VALUE)
		.endm

		.macro LD_R28_IMM VALUE
		ldi		r28,lo8(\VALUE)
		ldi		r29,hi8(\VALUE)
		.endm

		.macro LSLW_R21_R20
		clc
		rol		r20
		rol		r21
		.endm

		.macro RORW_R21_R20
		ror		r21
		ror		r20
		.endm

		.macro SRLW_R21_R20
		clc
		ror		r21
		ror		r20
		.endm

		.macro EX_DEHL
		push	r21
		push	r20
		mov		r21,r19
		mov		r20,r18
		pop		r18
		pop		r19
		.endm

		.macro ADD_IMM_R16 VALUE
		subi	r16,(-(\VALUE)) & 0xff
		.endm


